unit f_prgrss;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, atProgress;

type
  TfmatProgress = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edMin: TEdit;
    edMax: TEdit;
    Label2: TLabel;
    edStep: TEdit;
    Label3: TLabel;
    edPosition: TEdit;
    Label4: TLabel;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button4: TButton;
    Label5: TLabel;
    edMessage: TEdit;
    Button3: TButton;
    GroupBox3: TGroupBox;
    cbCancelButton: TCheckBox;
    cbShowPercent: TCheckBox;
    atProgress1: TatProgress;
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure cbCancelButtonClick(Sender: TObject);
    procedure cbShowPercentClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure atProgress1Cancel(Sender: TObject);
  private
    { Private declarations }
    procedure LoadProperties;
    procedure SetProperties;
  public
    { Public declarations }
  end;

var
  fmatProgress: TfmatProgress;

implementation

{$R *.DFM}

procedure TfmatProgress.LoadProperties;
begin
   With atProgress1 do
   begin
      edMin.Text:=IntToStr(Min);
      edMax.Text:=IntToStr(Max);
      edPosition.Text:=IntToStr(Position);
      edStep.Text:=IntToStr(Step);
      edMessage.Text:=InfoMessage;
   end;
end;

procedure TfmatProgress.SetProperties;
begin
   With atProgress1 do
   begin
      Min:=StrToInt(edMin.Text);
      Max:=StrToInt(edMax.Text);
      Position:=StrToInt(edPosition.Text);
      Step:=StrToInt(edStep.Text);
      InfoMessage:=edMessage.Text;
   end;
end;

procedure TfmatProgress.FormShow(Sender: TObject);
begin
   LoadProperties;
end;

procedure TfmatProgress.Button3Click(Sender: TObject);
begin
   SetProperties;
end;

procedure TfmatProgress.Button1Click(Sender: TObject);
begin
   atProgress1.Show;
end;

procedure TfmatProgress.Button2Click(Sender: TObject);
begin
   atProgress1.StepIt;
end;

procedure TfmatProgress.Button4Click(Sender: TObject);
begin
   atProgress1.Close;
end;

procedure TfmatProgress.cbCancelButtonClick(Sender: TObject);
begin
   if cbCancelButton.checked then
      atProgress1.Options:=atProgress1.Options+[poCancelButton]
   else
      atProgress1.Options:=atProgress1.Options-[poCancelButton];
end;

procedure TfmatProgress.cbShowPercentClick(Sender: TObject);
begin
   if cbShowPercent.checked then
      atProgress1.Options:=atProgress1.Options+[poShowPercent]
   else
      atProgress1.Options:=atProgress1.Options-[poShowPercent];
end;        

procedure TfmatProgress.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   atProgress1.Close;
end;                                    

procedure TfmatProgress.atProgress1Cancel(Sender: TObject);
begin
   ShowMessage('Process canceled.');
   atProgress1.Close;
end;

end.
